/* Copyright 2009, UCAR/Unidata and OPeNDAP, Inc.
   See the COPYRIGHT file for more information. */

#ifndef I_H
#define I_H

/* We need to define info to attach to
   the OCcontent structure (via public field)*/

typedef struct Icontent {
    size_t fieldindex; /*!<  the field for opendap_get_sequence_field */
} Icontent;

extern int opendap_connect(char* url, char* expr, OCnode**, int deflate, int connect_mode);

extern int opendap_node_info(OCnode* inode, char** namep, OCtype* typep, int* nsubnodesp,
                             int* hascontentp, int* hasattrsp, OCcontent** contentp);

extern int opendap_get_subnode(OCnode* inode, int isubnode, OCnode** subnodep, char** namep);

extern int opendap_get_int32(OCcontent* content, int* ivaluep, int mode);

extern int opendap_get_array(OCcontent* content, void* memoryp, char** arraynamep,
                             char*** dimnamesp, int mode);

extern int opendap_get_struct_info(OCcontent* content, int* nmembersp);

extern int opendap_get_struct_member(OCcontent*, int imember, OCtype* mtypep, OCcontent**);

extern int opendap_get_sequence_info(OCcontent* content, int* numrowsp, int* numfieldsp);

extern int opendap_get_sequence_field(OCnode* inode, OCcontent* content, int ifield,
	 		              char** fieldnamep, OCtype* fieldtypep,
			              OCnode** fieldnodep, OCcontent** fieldcontentp);

extern int opendap_get_sequence_row(OCnode* inode, OCcontent* content, OCtype fieldtype,
                                    int irow, OCcontent** rowfieldcontentp);


#endif /*I_H*/
